#include "StdAfx.h"
#include ".\mml_Address.h"

//==============================================================
//		RXgN^
//--------------------------------------------------------------
//	
//		unsigned	int		code
//		unsigned	int		length
//		unsigned	int		gatetime
//					bool	slur
//		const		char	_strName[]	NX̖O
//	Ԓl
//				
//==============================================================
mml_Address::mml_Address(unsigned char _code, const char _strName[]):
	MusicEvent(_strName)
{
	iSize = 3;
	code.resize(iSize);
	code[0] = _code;
	code[1] = 0;
	code[2] = 0;
}

mml_Address::mml_Address(unsigned char _code, unsigned char _data, const char _strName[]):
	MusicEvent(_strName)
{
	iSize = 4;
	code.resize(iSize);
	code[0] = _code;
	code[1] = _data;
	code[2] = 0;
	code[3] = 0;
}

//==============================================================
//		fXgN^
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
mml_Address::~mml_Address(void)
{
}

//==============================================================
//		AhX̐ݒ
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
void	mml_Address::set_Address(unsigned int _addr)
{
	switch(iSize){
		case(3):
			code[1] = ((_addr     ) & 0xFF);
			code[2] = ((_addr >> 8) & 0xFF);
			break;
		case(4):
			code[2] = ((_addr     ) & 0xFF);
			code[3] = ((_addr >> 8) & 0xFF);
			break;
		default:
			cout << "mml_Address::set_Address()֐ŃG[܂B" << endl;
			exit(-1);
			break;
	}
	

}

//==============================================================
//		AhX̎擾
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
/*
unsigned	int	mml_Address::get_Address(void)
{
	return((unsigned char)code[1] + ((unsigned char)code[2]<<8) );
}
*/

//==============================================================
//		id̐ݒ
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
void	mml_Address::set_id(unsigned int _id)
{
	m_id = _id;
}

//==============================================================
//		id̎擾
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
unsigned int	mml_Address::get_id(void)
{
	return(m_id);
}

